namespace Commonmark {

    public class AsciiMatcher : GLib.Object, CharMatcher {

        private BitSet bit_set;

        private AsciiMatcher(Builder builder) {
            this.bit_set = builder.bit_set;
        }

        public bool matches(unichar c) {
            return bit_set.get_bit((int)c);
        }

        public Builder new_builder() {
            return new Builder(bit_set.copy());
        }

        public static Builder builder() {
            return new Builder(new BitSet());
        }

        public class Builder {

            public BitSet bit_set { get; private set; }

            public Builder(BitSet bit_set) {
                this.bit_set = bit_set;
            }

            public Builder c(unichar c) {
                if (c > 127)
                    GLib.error("Can only match ASCII characters");
                bit_set.set_bit((int)c);
                return this;
            }

            public Builder range(unichar from, unichar to_inclusive) {
                for (unichar c = from; c <= to_inclusive; c++) {
                    this.c(c);
                }
                return this;
            }

            public AsciiMatcher build() {
                return new AsciiMatcher(this);
            }
        }
    }
}
