namespace Commonmark {

    public class BlockStartImpl : BlockStart {

        private BlockParser[] block_parsers;
        private int new_index = -1;
        private int new_column = -1;
        private bool _replace_active_block_parser = false;

        public BlockStartImpl.from(BlockParser parser) {
            this.block_parsers = new BlockParser[1];
            this.block_parsers[0] = parser;
        }

        public BlockStartImpl.from_two(BlockParser p1,
                                       BlockParser p2) {
            this.block_parsers = new BlockParser[2];
            this.block_parsers[0] = p1;
            this.block_parsers[1] = p2;
        }

        public BlockParser[] get_block_parsers() {
            return block_parsers;
        }

        public int get_new_index() {
            return new_index;
        }

        public int get_new_column() {
            return new_column;
        }

        public bool is_replace_active_block_parser() {
            return _replace_active_block_parser;
        }

        public override BlockStart at_index(int new_index) {
            this.new_index = new_index;
            return this;
        }

        public override BlockStart at_column(int new_column) {
            this.new_column = new_column;
            return this;
        }

        public override BlockStart replace_active_block_parser() {
            this._replace_active_block_parser = true;
            return this;
        }
    }
}
