namespace Commonmark {

    /**
     * Whether to include {@link Node.SourceSpan} or not while parsing, see
     * {@link Parser.Builder.include_source_spans}.
     */
    public enum IncludeSourceSpans {

        /**
         * Do not include source spans.
         */
        NONE,

        /**
         * Include source spans on {@link Node.Block} nodes.
         */
        BLOCKS,

        /**
         * Include source spans on block nodes and inline nodes.
         */
        BLOCKS_AND_INLINES;
    }
}
