namespace Commonmark {

    /**
     * Context for inline parsing.
     */
    public interface InlineParserContext : GLib.Object {

        /**
         * @return custom delimiter processors that have been configured with
         *  Parser.Builder#customDelimiterProcessor(DelimiterProcessor)
         */
        public abstract Gee.List<DelimiterProcessor>
        get_custom_delimiter_processors();

        /**
         * Look up a LinkReferenceDefinition for a given label.
         *
         * Note that the label is not normalized yet; implementations are
         * responsible for normalizing before lookup.
         *
         * @param label the link label to look up
         * @return the definition if one exists, null otherwise
         */
        public abstract LinkReferenceDefinition
        get_link_reference_definition(string label);
    }
}
