namespace Commonmark {

    /**
     * A link reference definition, e.g.:
     *
     * {{{
     *   [foo]: /url "title"
     * }}}
     *
     * They can be referenced anywhere else in the document to produce a link
     * using ''[foo]''. The definitions themselves are usually not rendered in
     * the final output.
     *
     * [[https://spec.commonmark.org/0.29/#link-reference-definition]]
     */
    public class LinkReferenceDefinition : Node {

        public string label { get; set; }
        public string destination { get; set; }
        public string title { get; set; }

        public LinkReferenceDefinition() {}

        public LinkReferenceDefinition.full(
            string label, string destination, string title) {
            this.label = label;
            this.destination = destination;
            this.title = title;
        }

        public override void accept(Visitor visitor) {
            visitor.visit(this);
        }
    }
}
