namespace Commonmark {

    public class LinkReferenceDefinitions : GLib.Object {

        /* LinkedHashMap for determinism and to preserve document order */
        private Gee.Map<string, LinkReferenceDefinition> definitions;

        construct {
            // definitions = new Gee.HashMap<string,
            //     LinkReferenceDefinition>();
            definitions = new LinkedMap<string, LinkReferenceDefinition>();
        }

        public void add(LinkReferenceDefinition definition) {
            var l = definition.label;
            var normalized_label = Escaping.normalize_label_content(l);

            /* spec: When there are multiple matching link reference
             * definitions, the first is used */
            if (!definitions.has_key(normalized_label)) {
                definitions[normalized_label] = definition;
            }
        }

        public LinkReferenceDefinition get_link(string label) {
            var normalized_label = Escaping.normalize_label_content(label);
            return definitions[normalized_label];
        }
    }
}
