namespace Commonmark {

    public class LinkedSet<G> : Gee.AbstractSet<G> {

        public override bool read_only { get { return false; } }
        public override int size { get { return _items.size; } }

        private Gee.LinkedList<G> _items;

        public LinkedSet() {
            _items = new Gee.LinkedList<G>();
        }

        public override bool add(G item) {
            if (item in _items)
                return false;
            _items.add(item);
            return true;
        }

        public override void clear() {
            _items.clear();
        }

        public override bool contains(G item) {
            return item in _items;
        }

        public override Gee.Iterator<G> iterator() {
            return _items.iterator();
        }

        public override bool remove(G item) {
            if (item in _items) {
                _items.remove(item);
                return true;
            }
            return false;
        }
    }
}

