namespace Commonmark {

    /**
     * A renderer for a set of node types.
     */
    public interface NodeRenderer : GLib.Object {

        /**
         * @return the types of nodes that this renderer handles
         */
        public abstract Gee.Set<GLib.Type> get_node_types();

        /**
         * Render the specified node.
         *
         * @param node the node to render, will be an instance of one of {@link
         * Commonmark.Renderer.NodeRenderer.get_node_types}
         */
        public abstract void render(Node node);
    }
}

