namespace Commonmark {

    public class SourceSpans : GLib.Object {

        private Gee.List<SourceSpan> source_spans;

        public static SourceSpans empty() {
            return new SourceSpans();
        }

        public Gee.List<SourceSpan> get_source_spans() {
            return source_spans != null ? source_spans :
                new Gee.ArrayList<SourceSpan>();
        }

        public void add_all_from(Gee.Iterable<Node> nodes) {
            foreach (Node node in nodes) {
                add_all(node.source_spans);
            }
        }

        public void add_all(Gee.List<SourceSpan> other) {
            if (other.is_empty) {
                return;
            }

            if (source_spans == null) {
                source_spans = new Gee.ArrayList<SourceSpan>();
            }

            if (source_spans.is_empty) {
                source_spans.add_all(other);
            } else {
                int last_index = source_spans.size - 1;
                SourceSpan a = source_spans.get(last_index);
                SourceSpan b = other.get(0);
                if (a.line_index == b.line_index &&
                    a.column_index + a.length == b.column_index) {
                    source_spans.set(
                        last_index, SourceSpan.from(a.line_index,
                                                    a.column_index,
                                                    a.length + b.length));
                    source_spans.add_all(other.slice(1, other.size));
                } else {
                    source_spans.add_all(other);
                }
            }
        }
    }
}
