namespace Commonmark {

    public interface TextContentNodeRendererContext : GLib.Object {

        /**
         * @return true for stripping new lines and render text as "single line",
         * false for keeping all line breaks.
         */
        public abstract bool strip_newlines();

        /**
         * @return the writer to use
         */
        public abstract TextContentWriter get_writer();

        /**
         * Render the specified node and its children using the configured
         * renderers. This should be used to render child nodes; be careful not
         * to pass the node that is being rendered, that would result in an
         * endless loop.
         *
         * @param node the node to render
         */
        public abstract void render(Node node);
    }
}
