namespace Commonmark {

    /**
     * Factory for instantiating new node renderers when rendering is done.
     */
    public interface TextContentNodeRendererFactory : GLib.Object {

        /**
         * Create a new node renderer for the specified rendering context.
         *
         * @param context the context for rendering (normally passed on to the
         * node renderer)
         * @return a node renderer
         */
        public abstract NodeRenderer
            create(TextContentNodeRendererContext context);
    }
}

